Package org.apache.sling.feature.maven.mojos

# Class AbstractIncludingFeatureMojo

java.lang.Object
org.apache.maven.plugin.AbstractMojo
org.apache.sling.feature.maven.mojos.AbstractFeatureMojo
org.apache.sling.feature.maven.mojos.AbstractIncludingFeatureMojo

All Implemented Interfaces:
  `org.apache.maven.plugin.ContextEnabled`, `org.apache.maven.plugin.Mojo`

Direct Known Subclasses:
  `AbstractRepositoryMojo`, `AggregateFeaturesMojo`, `AnalyseFeaturesMojo`, `ApisJarMojo`, `ApplyDefaultConfigMojo`, `AttachFeatureArchivesMojo`, `EmbedFeaturesMojo`, `ExtractExtensionMojo`, `FeatureLauncherMojo`, `FeaturesDiffMojo`, `IncludeArtifactMojo`, `InfoMojo`, `UpdateVersionsMojo`

public abstract class AbstractIncludingFeatureMojo extends AbstractFeatureMojo

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static class`
`AbstractIncludingFeatureMojo.FeatureScanner`

## Nested classes/interfaces inherited from class org.apache.sling.feature.maven.mojos.AbstractFeatureMojo

`AbstractFeatureMojo.BaseArtifactProvider, AbstractFeatureMojo.BaseFeatureProvider`

## Field Summary

### Fields inherited from class org.apache.sling.feature.maven.mojos.AbstractFeatureMojo

`defaultMetadata, features, jarStartOrder, mavenSession, project, projectHelper`

### Fields inherited from interface org.apache.maven.plugin.Mojo

`ROLE`

## Constructor Summary

Constructors
Constructor
Description
`AbstractIncludingFeatureMojo()`

## Method Summary

Modifier and Type
Method
Description
`protected Map<String,org.apache.sling.feature.Feature>`
`getSelectedFeatures(FeatureSelectionConfig config)`
Get all selected features for the provided configuration
`protected Map<String,org.apache.sling.feature.Feature>`
`selectAllFeatureFiles()`
Select all feature files from the project
`protected Map<String,org.apache.sling.feature.Feature>`
`selectAllFeatureFilesAndAggregates()`
Select all features including aggregates from the project

### Methods inherited from class org.apache.sling.feature.maven.mojos.AbstractFeatureMojo

`checkPreconditions, getTmpDir`

### Methods inherited from class org.apache.maven.plugin.AbstractMojo

`getLog, getPluginContext, setLog, setPluginContext`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.apache.maven.plugin.Mojo

`execute`

## Constructor Details

### AbstractIncludingFeatureMojo

public AbstractIncludingFeatureMojo()

## Method Details

### getSelectedFeatures

protected Map<String,org.apache.sling.feature.Feature> getSelectedFeatures(FeatureSelectionConfig config) throws org.apache.maven.plugin.MojoExecutionException
Get all selected features for the provided configuration

Parameters:
  `config` - The selection configuration
Returns:
  An ordered map of features
Throws:
  `org.apache.maven.plugin.MojoExecutionException` - If an incorrect configuration is found

### selectAllFeatureFiles

protected Map<String,org.apache.sling.feature.Feature> selectAllFeatureFiles() throws org.apache.maven.plugin.MojoExecutionException
Select all feature files from the project

Returns:
  Ordered map of feature files
Throws:
  `org.apache.maven.plugin.MojoExecutionException` - If an incorrect configuration is found

### selectAllFeatureFilesAndAggregates

protected Map<String,org.apache.sling.feature.Feature> selectAllFeatureFilesAndAggregates() throws org.apache.maven.plugin.MojoExecutionException
Select all features including aggregates from the project

Returns:
  Ordered map of features
Throws:
  `org.apache.maven.plugin.MojoExecutionException` - If an incorrect configuration is found